Lock (Apache Tomcat 9.0.37 API Documentation)

org.apache.tomcat.jni

## Class Lock

- java.lang.Object
- - org.apache.tomcat.jni.Lock

-     public class Lock
      extends Object

  Lock
  Author:
    Mladen Turk

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `APR_LOCK_DEFAULT` POSIX semaphore process-based locking
    `static int` | `APR_LOCK_FCNTL` Enumerated potential types for APR process locking methods Warning : Check APR_HAS_foo_SERIALIZE defines to see if the platform supports APR_LOCK_foo.
    `static int` | `APR_LOCK_FLOCK` fcntl()
    `static int` | `APR_LOCK_POSIXSEM` POSIX pthread process-based locking
    `static int` | `APR_LOCK_PROC_PTHREAD` System V Semaphores
    `static int` | `APR_LOCK_SYSVSEM` flock()

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Lock()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static long` | `childInit(String fname, long pool)` Re-open a mutex in a child process.
    `static long` | `create(String fname, int mech, long pool)` Create and initialize a mutex that can be used to synchronize processes.
    `static String` | `defname()` Display the name of the default mutex: APR_LOCK_DEFAULT
    `static int` | `destroy(long mutex)` Destroy the mutex and free the memory associated with the lock.
    `static int` | `lock(long mutex)` Acquire the lock for the given mutex.
    `static String` | `lockfile(long mutex)` Return the name of the lockfile for the mutex, or NULL if the mutex doesn't use a lock file
    `static String` | `name(long mutex)` Display the name of the mutex, as it relates to the actual method used.
    `static int` | `trylock(long mutex)` Attempt to acquire the lock for the given mutex.
    `static int` | `unlock(long mutex)` Release the lock for the given mutex.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### APR_LOCK_FCNTL

          public static final int APR_LOCK_FCNTL

      Enumerated potential types for APR process locking methods
      Warning : Check APR_HAS_foo_SERIALIZE defines to see if the platform supports APR_LOCK_foo. Only APR_LOCK_DEFAULT is portable.
      See Also:
        Constant Field Values

    - #### APR_LOCK_FLOCK

          public static final int APR_LOCK_FLOCK

      fcntl()
      See Also:
        Constant Field Values

    - #### APR_LOCK_SYSVSEM

          public static final int APR_LOCK_SYSVSEM

      flock()
      See Also:
        Constant Field Values

    - #### APR_LOCK_PROC_PTHREAD

          public static final int APR_LOCK_PROC_PTHREAD

      System V Semaphores
      See Also:
        Constant Field Values

    - #### APR_LOCK_POSIXSEM

          public static final int APR_LOCK_POSIXSEM

      POSIX pthread process-based locking
      See Also:
        Constant Field Values

    - #### APR_LOCK_DEFAULT

          public static final int APR_LOCK_DEFAULT

      POSIX semaphore process-based locking
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Lock

          public Lock()

  - ### Method Detail

    - #### create

          public static long create(String fname,
                                    int mech,
                                    long pool)
                             throws Error

      Create and initialize a mutex that can be used to synchronize processes.
      Warning : Check APR_HAS_foo_SERIALIZE defines to see if the platform supports APR_LOCK_foo. Only APR_LOCK_DEFAULT is portable.
      Parameters:
        `fname` - A file name to use if the lock mechanism requires one. This argument should always be provided. The lock code itself will determine if it should be used.
        `mech` - The mechanism to use for the interprocess lock, if any; one of

                        APR_LOCK_FCNTL
                        APR_LOCK_FLOCK
                        APR_LOCK_SYSVSEM
                        APR_LOCK_POSIXSEM
                        APR_LOCK_PROC_PTHREAD
                        APR_LOCK_DEFAULT     pick the default mechanism for the platform

        `pool` - the pool from which to allocate the mutex.
      Returns:
        Newly created mutex.
      Throws:
        `Error` - An error occurred

    - #### childInit

          public static long childInit(String fname,
                                       long pool)
                                throws Error

      Re-open a mutex in a child process. This function must be called to maintain portability, even if the underlying lock mechanism does not require it.
      Parameters:
        `fname` - A file name to use if the mutex mechanism requires one. This argument should always be provided. The mutex code itself will determine if it should be used. This filename should be the same one that was passed to apr_proc_mutex_create().
        `pool` - The pool to operate on.
      Returns:
        Newly opened mutex.
      Throws:
        `Error` - An error occurred

    - #### lock

          public static int lock(long mutex)

      Acquire the lock for the given mutex. If the mutex is already locked, the current thread will be put to sleep until the lock becomes available.
      Parameters:
        `mutex` - the mutex on which to acquire the lock.
      Returns:
        the operation status

    - #### trylock

          public static int trylock(long mutex)

      Attempt to acquire the lock for the given mutex. If the mutex has already been acquired, the call returns immediately with APR_EBUSY. Note: it is important that the APR_STATUS_IS_EBUSY(s) macro be used to determine if the return value was APR_EBUSY, for portability reasons.
      Parameters:
        `mutex` - the mutex on which to attempt the lock acquiring.
      Returns:
        the operation status

    - #### unlock

          public static int unlock(long mutex)

      Release the lock for the given mutex.
      Parameters:
        `mutex` - the mutex from which to release the lock.
      Returns:
        the operation status

    - #### destroy

          public static int destroy(long mutex)

      Destroy the mutex and free the memory associated with the lock.
      Parameters:
        `mutex` - the mutex to destroy.
      Returns:
        the operation status

    - #### lockfile

          public static String lockfile(long mutex)

      Return the name of the lockfile for the mutex, or NULL if the mutex doesn't use a lock file
      Parameters:
        `mutex` - the name of the mutex
      Returns:
        the name of the lock file

    - #### name

          public static String name(long mutex)

      Display the name of the mutex, as it relates to the actual method used. This matches the valid options for Apache's AcceptMutex directive
      Parameters:
        `mutex` - the name of the mutex
      Returns:
        the name of the mutex

    - #### defname

          public static String defname()

      Display the name of the default mutex: APR_LOCK_DEFAULT
      Returns:
        the default name

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.